开发者

Solidworks & Excel C# Referencing the Design Table

开发者 https://www.devze.com 2023-04-04 22:23 出处:网络
I can\'t get my design table to modify when opened the line I am having the trouble is var sheet = (Excel._Worksheet)swDoc.GetDesignTable; . Essentially what I want it to do is open the window and ref

I can't get my design table to modify when opened the line I am having the trouble is var sheet = (Excel._Worksheet)swDoc.GetDesignTable; . Essentially what I want it to do is open the window and reference the active sheet which is the "Design Table". The API does include "DesignTable" as type. I have been stuck for a while. Any help is appreciated.

        //Open Solidworks Design Table
        SldWorks swApp;
        swApp = null;
        swApp = (SldWorks)Activator.CreateInstance(Type.GetTypeFromProgID("SldWorks.Application"));

        ModelDoc2 swDoc = null;
        bool boolstatus = false;
        swDoc = ((ModelDoc2)(swApp.ActiveDoc));
        boolstatus = swDoc.Extension.SelectByID2("Design Table", "DESIGNTABLE", 0, 0,开发者_如何学Go 0, false, 0, null, 0);
        swDoc.InsertFamilyTableEdit();
        var sheet = (Excel._Worksheet)swDoc.GetDesignTable;

        //Generate Linear Guide Support in Solidworks
        if (comboBox1.Text == "0")//No External Rails
        {
           sheet.Cells[6, 4] = "0"; //Cell Location [y-axis, x-axis]
        }


Figured it out

   using Excel = Microsoft.Office.Interop.Excel; //Excel Reference 

   public virtual Object ActiveSheet { get; set; } //Gets ActiveSheet from Excel (MUST HAVE!!!)


     private void button15_Click(object sender, EventArgs e)
        {
        //Allows Access to Solidworks (without SDK add-in)
        SldWorks swApp;
        swApp = null;
        swApp = (SldWorks)Activator.CreateInstance(Type.GetTypeFromProgID("SldWorks.Application"));

        ModelDoc2 swDoc = null;
        bool boolstatus = false;
        swDoc = ((ModelDoc2)(swApp.ActiveDoc));
        boolstatus = swDoc.Extension.SelectByID2("Design Table", "DESIGNTABLE", 0, 0, 0, false, 0, null, 0);

        //Open Solidworks Design Table
        swDoc.InsertFamilyTableEdit();

        //Gets ActiveSheet to Modify
        Excel.Application oXL;
        Excel.Workbook oWB;
        Excel.Worksheet oSheet;

        //Start Excel and get Application object.
        oXL = (Excel.Application)Marshal.GetActiveObject("Excel.Application"); 
        oXL.Visible = true;
        oWB = (Excel.Workbook)oXL.ActiveWorkbook; 
        oSheet = (Excel.Worksheet)oWB.ActiveSheet;
        //Generate Linear Guide Support in Solidworks    
        if (comboBox1.Text == "0")//No External Rails    
        {    
         sheet.Cells[6, 4] = "0"; //Cell Location [y-axis, x-axis]    
        }    

        //Close Design Table
        swDoc.CloseFamilyTable();

        //Quit Excel
        oXL.Quit();
        }
0

精彩评论

暂无评论...
验证码 换一张
取 消

关注公众号